
-------------------------------------------------------------------------------
--! @file       RC0_LUT.vhd
--! @author     William Diehl
--! @brief      SCREAM RC0_LUT
--! @date       4 Jul 2016
-------------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY RC0_LUT IS

	PORT(
		sigma: in std_logic_vector(3 downto 0);
		rc: out std_logic_vector(15 downto 0)
	);

END RC0_LUT;

ARCHITECTURE dataflow OF RC0_LUT IS

SIGNAL index: INTEGER RANGE 0 TO 15;
TYPE vector_array IS ARRAY (0 to 15) OF STD_LOGIC_VECTOR(15 DOWNTO 0);
CONSTANT memory : vector_array := 
	(

	x"0000", x"112e", x"225c", x"338a", x"44b8", x"55e6",
	x"6714", x"7842", x"8970", x"9a9e", x"abcc", x"bcfa",
        x"0000", x"0000", x"0000", x"0000"
	);

BEGIN

	index <= to_integer(unsigned(sigma));
	rc <= memory(index);

END dataflow;




