
-------------------------------------------------------------------------------
--! @file       RC1_LUT.vhd
--! @author     William Diehl
--! @brief      SCREAM RC1_LUT
--! @date       4 Jul 2016
-------------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY RC1_LUT IS

	PORT(
		sigma: in std_logic_vector(3 downto 0);
		rc: out std_logic_vector(15 downto 0)
	);

END RC1_LUT;

ARCHITECTURE dataflow OF RC1_LUT IS

SIGNAL index: INTEGER RANGE 0 TO 15;
TYPE vector_array IS ARRAY (0 to 15) OF STD_LOGIC_VECTOR(15 DOWNTO 0);
CONSTANT memory : vector_array := 
	(

        x"0897", x"19c5", x"2af3", x"3c21", x"4d4f", x"5e7d",
        x"6fab", x"80d9", x"9207", x"a335", x"b463", x"c591",
	x"0000", x"0000", x"0000", x"0000"           
	
);

BEGIN

	index <= to_integer(unsigned(sigma));
	rc <= memory(index);

END dataflow;




