-------------------------------------------------------------------------------
--! @file       Feistel_B.vhd
--! @author     William Diehl
--! @brief      SCREAM Feistel_B
--! @date       29 Jun 2016
-------------------------------------------------------------------------------


LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity Feistel_B is
	port(

         x0: in std_logic_vector(15 downto 0);
         x1: in std_logic_vector(15 downto 0);
         x2: in std_logic_vector(15 downto 0);
         x3: in std_logic_vector(15 downto 0);
         x4: in std_logic_vector(15 downto 0);
         x5: in std_logic_vector(15 downto 0);
         x6: in std_logic_vector(15 downto 0);
         x7: in std_logic_vector(15 downto 0);

	      w0: out std_logic_vector(15 downto 0);
         w1: out std_logic_vector(15 downto 0);
    	   w2: out std_logic_vector(15 downto 0);
         w3: out std_logic_vector(15 downto 0)
         );
	 
end Feistel_B;

architecture dataflow of Feistel_B is

SIGNAL	t0:	STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	t1:	STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	t2:	STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL	t3:	STD_LOGIC_VECTOR(15 DOWNTO 0);

begin

t0 <= (x4 and x5) xor x6;
t1 <= (x5 or x6) xor x7;
t2 <= (x7 and t0) xor x4;
t3 <= (x4 and t1) xor x5;
w0 <= x0 xor t0;
w2 <= x2 xor t1;
w1 <= x1 xor t2;
w3 <= x3 xor t3;

end dataflow;

