-------------------------------------------------------------------------------
--! @file       LBox_128_alt.vhd
--! @author     William Diehl
--! @brief      SCREAM LBox_128_alt
--! @date       29 Jun 2016
-------------------------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY L_box_128_alt IS
	PORT(
	 
	 x:	IN STD_LOGIC_VECTOR(127 DOWNTO 0);
	 w:	OUT STD_LOGIC_VECTOR(127 DOWNTO 0));

END L_box_128_alt;

ARCHITECTURE structural OF L_box_128_alt IS

SIGNAL a0, a1, a2, a3, a4, a5, a6, a7 : STD_LOGIC_VECTOR(15 DOWNTO 0);
SIGNAL b0, b1, b2, b3, b4, b5, b6, b7 : STD_LOGIC_VECTOR(15 DOWNTO 0);


BEGIN


	U1: entity work.LBox_2(dataflow)
		PORT MAP(

		Addr => x(127 DOWNTO 120),
		dout => a0);


	U2: entity work.LBox_1(dataflow)
		PORT MAP(

		Addr => x(119 DOWNTO 112),
		dout => b0);

w(127 DOWNTO 112) <= a0 XOR b0;


	U3: entity work.LBox_2(dataflow)
		PORT MAP(

		Addr => x(111 DOWNTO 104),
		dout => a1);


	U4: entity work.LBox_1(dataflow)
		PORT MAP(

		Addr => x(103 DOWNTO 96),
		dout => b1);

w(111 DOWNTO 96) <= a1 XOR b1;


	U5: entity work.LBox_2(dataflow)
		PORT MAP(

		Addr => x(95 DOWNTO 88),
		dout => a2);


	U6: entity work.LBox_1(dataflow)
		PORT MAP(

		Addr => x(87 DOWNTO 80),
		dout => b2);

w(95 DOWNTO 80) <= a2 XOR b2;


	U7: entity work.LBox_2(dataflow)
		PORT MAP(

		Addr => x(79 DOWNTO 72),
		dout => a3);


	U8: entity work.LBox_1(dataflow)
		PORT MAP(

		Addr => x(71 DOWNTO 64),
		dout => b3);

w(79 DOWNTO 64) <= a3 XOR b3;


	U9: entity work.LBox_2(dataflow)
		PORT MAP(

		Addr => x(63 DOWNTO 56),
		dout => a4);


	U10: entity work.LBox_1(dataflow)
		PORT MAP(

		Addr => x(55 DOWNTO 48),
		dout => b4);

w(63 DOWNTO 48) <= a4 XOR b4;


	U11: entity work.LBox_2(dataflow)
		PORT MAP(

		Addr => x(47 DOWNTO 40),
		dout => a5);


	U12: entity work.LBox_1(dataflow)
		PORT MAP(

		Addr => x(39 DOWNTO 32),
		dout => b5);

w(47 DOWNTO 32) <= a5 XOR b5;


	U13: entity work.LBox_2(dataflow)
		PORT MAP(

		Addr => x(31 DOWNTO 24),
		dout => a6);


	U14: entity work.LBox_1(dataflow)
		PORT MAP(

		Addr => x(23 DOWNTO 16),
		dout => b6);

w(31 DOWNTO 16) <= a6 XOR b6;


	U15: entity work.LBox_2(dataflow)
		PORT MAP(

		Addr => x(15 DOWNTO 8),
		dout => a7);


	U16: entity work.LBox_1(dataflow)
		PORT MAP(

		Addr => x(7 DOWNTO 0),
		dout => b7);

w(15 DOWNTO 0) <= a7 XOR b7;



END structural;

